﻿''
'' ConsoleVB
''
'' Copyright (c) 2018 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Module Module1

    Sub Main()
        'Decimal型 を Integer型 に変換
        Console.WriteLine("Decimal型 を Integer型 に変換")
        Test1()

        'マイナス値の場合
        Console.WriteLine("")
        Console.WriteLine("マイナス値の場合")
        Test2()

        '桁あふれする場合
        Console.WriteLine("")
        Console.WriteLine("桁あふれする場合")
        Test3()

        Console.ReadLine()
    End Sub


    ''' <summary>
    ''' Decimal型 を Integer型 に変換
    ''' </summary>
    Sub Test1()
        Dim decimalValue As Decimal = 5.1

        'Decimal型 -> Integer型(少数は切り捨てされる)
        Dim intValue As Integer = Decimal.ToInt32(decimalValue)

        '結果は 5
        Console.WriteLine(intValue)
    End Sub

    ''' <summary>
    ''' マイナス値の場合
    ''' </summary>
    Sub Test2()
        'マイナス値の場合
        Dim decimalValue As Decimal = -5.1
        Dim intValue As Integer = Decimal.ToInt32(decimalValue)

        '結果 -> -5
        Console.WriteLine(intValue)
    End Sub

    ''' <summary>
    ''' 桁あふれする場合
    ''' </summary>
    Sub Test3()
        Try
            '桁あふれする場合
            Dim decimalValue As Decimal = 2147483647D + 1D

            '例外(System.OverflowException)が発生する
            Dim intValue As Integer = Decimal.ToInt32(decimalValue)
        Catch ex As Exception
            '結果 -> System.OverflowException
            Console.WriteLine(ex.GetType())

            '結果 -> Int32 型の値が大きすぎるか、または小さすぎます。
            Console.WriteLine(ex.Message)
        End Try
    End Sub

End Module
